const {
  clipToBits,
  bitsToClip,
} = require('./clip-bits')

describe('clipToBits', () => {
  it('Works for valid input', () => {
    expect(clipToBits('A'))
      .toEqual('000000')
    expect(clipToBits('AA'))
      .toEqual('000000000000')
    expect(clipToBits('B'))
      .toEqual('000001')
    expect(clipToBits('AB'))
      .toEqual('000001000000')
    expect(clipToBits('4lv4r0-cuesta_github'))
      .toEqual('011011101110100001101101100010100000111110011010101101101100011110101110011100111111110100101011111000101111100101111000')
  })

  it('Works for the empty string', () => {
    expect(clipToBits('')).toEqual('')
  })

  it('Throws when receiving an invalid character', () => {
    expect(() => clipToBits('??'))
      .toThrow('Invalid clip string character ?')
    expect(() => clipToBits('+'))
      .toThrow('Invalid clip string character +')
    expect(() => clipToBits('AaA+'))
      .toThrow('Invalid clip string character +')
    expect(() => clipToBits('+AaA'))
      .toThrow('Invalid clip string character +')
  })
})
